<template>
  <div class="py-8 px-4 lg:py-16 lg:px-12">
    <UBreadcrumb :links="links" />
    <div class="flex flex-col md:flex-row items-center justify-between space-y-3 md:space-y-0 md:space-x-4 p-4">
      <div class="w-full md:w-1/2">
        <form class="flex items-center">
          <label for="simple-search" class="sr-only">Search</label>
          <div class="relative w-full">
            <div class="absolute inset-y-0 left-0 flex items-center pl-3 pointer-events-none">
              <svg aria-hidden="true" class="w-5 h-5 text-gray-500 dark:text-gray-400" fill="currentColor" viewbox="0 0 20 20" xmlns="http://www.w3.org/2000/svg">
                <path fill-rule="evenodd" d="M8 4a4 4 0 100 8 4 4 0 000-8zM2 8a6 6 0 1110.89 3.476l4.817 4.817a1 1 0 01-1.414 1.414l-4.816-4.816A6 6 0 012 8z" clip-rule="evenodd" />
              </svg>
            </div>
            <UInput v-model="q" placeholder="Filter flux..." />
          </div>
        </form>
      </div>
      <div class="w-full md:w-auto flex flex-col md:flex-row space-y-2 md:space-y-0 items-stretch md:items-center justify-end md:space-x-3 flex-shrink-0">
        <NuxtLink to="/flux/new" class="flex items-center justify-center text-white bg-primary-700 hover:bg-primary-800 focus:ring-4 focus:ring-primary-300 font-medium rounded-lg text-sm px-4 py-2 dark:bg-primary-600 dark:hover:bg-primary-700 focus:outline-none dark:focus:ring-primary-800">
          <UIcon name="i-heroicons-plus-16-solid" class="text-2xl mr-4" />
          Ajouter un flux
        </NuxtLink>
      </div>
    </div>
    <UTable :rows="filteredRows" :columns="columns" :loading="loading" @select="select">
      <template #createdAt-data="{ row }">
        {{ moment(row.createdAt).format('DD/MM/YYYY') }}
      </template>
      <template #actions-data="{ row }">
        <UButton type="button" class="py-2 px-3 text-sm font-medium text-center text-white bg-red-600 rounded-lg hover:bg-red-700 focus:ring-4 focus:outline-none focus:ring-red-300 dark:bg-red-500 dark:hover:bg-red-600 dark:focus:ring-red-900">
          <UIcon name="i-heroicons-trash" />
        </UButton>
      </template>
    </UTable>
    <div class="flex justify-end px-3 py-3.5 border-t border-gray-200 dark:border-gray-700">
      <UPagination v-model="page" :page-count="pageCount" :total="data.length" />
    </div>
  </div>
</template>

<script setup lang="ts">
import { useNuxtApp } from '#app'
import type { Api } from '~/types/api'
import moment from "moment/moment";

const data = ref({})
const loading = ref(true)
const error = ref(null)
const page = ref(1)
const pageCount = 5
const router = useRouter()

const nuxtApp = useNuxtApp()
const $api = nuxtApp.$api as Api

const columns = [
  {
    key: 'name',
    label: 'Nom flux'
  },
  {
    key: 'type',
    label: 'Type '
  },
  {
    key: 'createdAt',
    label: 'Créé le'
  },
  {
    key: 'flux_url',
    label: 'Url'
  }, {
    key: 'actions',
    label: 'Actions'
  }]

async function loadData() {
  try {
    const response = await $api.getFlux()
    data.value = response
    console.log(response)
  } catch (err) {
    error.value = err.message
    console.error('Error fetching data:', err)
  } finally {
    loading.value = false
  }
}
async function select (row) {
  console.log(row.Flux_id)
  await router.push('/flux/' + row.Flux_id )
}

const q = ref('')

const filteredRows = computed(() => {
  if (!q.value) {
    return data.value
  }

  return data.filter((item) => {
    return Object.values(item).some((value) => {
      return String(value).toLowerCase().includes(q.value.toLowerCase())
    })
  })
})

const links = [{
  label: 'Home',
  icon: 'i-heroicons-home',
  to: '/feed'
}, {
  label: 'Flux',
  icon: 'i-heroicons-square-3-stack-3d'
}]

onMounted(() => {
  loadData()
})
</script>